Exiv2::Internal::TiffIfdMakernote Class Reference

Tiff IFD Makernote. This is a concrete class suitable for all IFD makernotes. More...

`#include <tiffcomposite_int.hpp>`

Inheritance diagram for Exiv2::Internal::TiffIfdMakernote:
[legend]

## Public Member Functions

Creators
| TiffIfdMakernote (uint16_t tag, IfdId group, IfdId mnGroup, MnHeader *pHeader, bool hasNext=true)
| Default constructor.
virtual | ~TiffIfdMakernote ()
| Virtual destructor.
Manipulators
bool | readHeader (const byte *pData, uint32_t size, ByteOrder byteOrder)
| Read the header from a data buffer, return true if successful. More...
void | setByteOrder (ByteOrder byteOrder)
| Set the byte order for the makernote.
void | setImageByteOrder (ByteOrder byteOrder)
| Set the byte order used for the image.
Accessors
uint32_t | sizeHeader () const
| Return the size of the header in bytes.
uint32_t | writeHeader (IoWrapper &ioWrapper, ByteOrder byteOrder) const
| Write the header to a data buffer, return the number of bytes written.
uint32_t | mnOffset () const
| Return the offset to the makernote from the start of the TIFF header.
uint32_t | ifdOffset () const
| Return the offset to the start of the Makernote IFD from the start of the Makernote. Returns 0 if there is no header.
ByteOrder | byteOrder () const
| Return the byte order for the makernote. Requires the image byte order to be set (setImageByteOrder()). Returns the byte order for the image if there is no header or the byte order for the header is `invalidByteOrder`.
ByteOrder | imageByteOrder () const
| Return the byte order used for the image.
uint32_t | baseOffset () const
| Return the base offset for use with the makernote IFD entries relative to the start of the TIFF header. Returns 0 if there is no header.
Public Member Functions inherited from Exiv2::Internal::TiffComponent
| TiffComponent (uint16_t tag, IfdId group)
| Constructor.
virtual | ~TiffComponent ()
| Virtual destructor.
TiffComponent * | addPath (uint16_t tag, TiffPath &tiffPath, TiffComponent *const pRoot, AutoPtr object=AutoPtr(0))
| Add a TIFF entry tag to the component. Components on the path to the entry are added if they don't exist yet. More...
TiffComponent * | addChild (AutoPtr tiffComponent)
| Add a child to the component. Default is to do nothing. More...
TiffComponent * | addNext (AutoPtr tiffComponent)
| Add a "next" component to the component. Default is to do nothing. More...
void | accept (TiffVisitor &visitor)
| Interface to accept visitors (Visitor pattern). Visitors can perform operations on all components of the composite. More...
void | setStart (const byte *pStart)
| Set a pointer to the start of the binary representation of the component in a memory buffer. The buffer must be allocated and freed outside of this class.
uint32_t | write (IoWrapper &ioWrapper, ByteOrder byteOrder, int32_t offset, uint32_t valueIdx, uint32_t dataIdx, uint32_t &imageIdx)
| Write a TiffComponent to a binary image. More...
uint16_t | tag () const
| Return the tag of this entry.
IfdId | group () const
| Return the group id of this component.
byte * | start () const
| Return a pointer to the start of the binary representation of the component.
AutoPtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy, but without any children). The caller owns this copy and the auto-pointer ensures that it will be deleted.
uint32_t | writeData (IoWrapper &ioWrapper, ByteOrder byteOrder, int32_t offset, uint32_t dataIdx, uint32_t &imageIdx) const
| Write the IFD data of this component to a binary image. Return the number of bytes written. Components derived from TiffEntryBase implement this method if needed.
uint32_t | writeImage (IoWrapper &ioWrapper, ByteOrder byteOrder) const
| Write the image data of this component to a binary image. Return the number of bytes written. TIFF components implement this method if needed.
uint32_t | size () const
| Return the size in bytes of the IFD value of this component when written to a binary image.
uint32_t | count () const
| Return the number of components in this component.
uint32_t | sizeData () const
| Return the size in bytes of the IFD data of this component when written to a binary image. This is a support function for write(). Components derived from TiffEntryBase implement this method corresponding to their implementation of writeData().
uint32_t | sizeImage () const
| Return the size in bytes of the image data of this component when written to a binary image. This is a support function for write(). TIFF components implement this method corresponding to their implementation of writeImage().
virtual int | idx () const
| Return the unique id of the entry in the image.

## Protected Member Functions

Protected Manipulators
virtual TiffComponent * | doAddPath (uint16_t tag, TiffPath &tiffPath, TiffComponent *const pRoot, TiffComponent::AutoPtr object)
| Implements addPath(). The default implementation does nothing.
virtual TiffComponent * | doAddChild (TiffComponent::AutoPtr tiffComponent)
| Implements addChild(). The default implementation does nothing.
virtual TiffComponent * | doAddNext (TiffComponent::AutoPtr tiffComponent)
| Implements addNext(). The default implementation does nothing.
virtual void | doAccept (TiffVisitor &visitor)
| Implements accept().
virtual uint32_t | doWrite (IoWrapper &ioWrapper, ByteOrder byteOrder, int32_t offset, uint32_t valueIdx, uint32_t dataIdx, uint32_t &imageIdx)
| Implements write(). Write the Makernote header, TIFF directory, values and additional data to the ioWrapper, return the number of bytes written.
Protected Accessors
virtual TiffIfdMakernote * | doClone () const
| Internal virtual copy constructor, implements clone().
virtual uint32_t | doWriteData (IoWrapper &ioWrapper, ByteOrder byteOrder, int32_t offset, uint32_t dataIdx, uint32_t &imageIdx) const
| This class does not really implement writeData(), it only has write(). This method must not be called; it commits suicide.
virtual uint32_t | doWriteImage (IoWrapper &ioWrapper, ByteOrder byteOrder) const
| Implements writeImage(). Write the image data of the IFD of the Makernote. Return the number of bytes written.
virtual uint32_t | doSize () const
| Implements size(). Return the size of the Makernote header, TIFF directory, values and additional data.
virtual uint32_t | doCount () const
| Implements count(). Return the number of entries in the IFD of the Makernote. Does not count entries which are marked as deleted.
virtual uint32_t | doSizeData () const
| This class does not really implement sizeData(), it only has size(). This method must not be called; it commits suicide.
virtual uint32_t | doSizeImage () const
| Implements sizeImage(). Return the total image data size of the makernote IFD.
Protected Member Functions inherited from Exiv2::Internal::TiffComponent

## Friends

class | TiffReader

## Additional Inherited Members

Public Types inherited from Exiv2::Internal::TiffComponent
typedef std::auto_ptr< TiffComponent > | AutoPtr
| TiffComponent auto_ptr type.
typedef std::vector< TiffComponent * > | Components
| Container type to hold all metadata.

## Detailed Description

Tiff IFD Makernote. This is a concrete class suitable for all IFD makernotes.

Contains a makernote header (which can be 0) and an IFD and implements child mgmt functions to deal with the IFD entries. The various makernote weirdnesses are taken care of in the makernote header (and possibly in special purpose IFD entries).

## Member Function Documentation

## readHeader()

bool Exiv2::Internal::TiffIfdMakernote::readHeader | ( | const byte * | pData,
|  | uint32_t | size,
|  | ByteOrder | byteOrder
| ) |  |

Read the header from a data buffer, return true if successful.

The default implementation simply returns true.

References byteOrder(), Exiv2::Internal::MnHeader::read(), and Exiv2::Internal::TiffComponent::size().

Referenced by Exiv2::Internal::TiffReader::visitIfdMakernote().

The documentation for this class was generated from the following files:

- tiffcomposite_int.hpp
- tiffcomposite_int.cpp